(set-logic ALL)
(declare-fun ackermann (Int Int Int) Bool)

; ackermann
(assert (forall ((m Int) (n Int) (r Int))
  (and
    (=> (ackermann m n r)
        (or (and (= m 0) (= r (+ n 1)))
        (or (and (= n 0) (ackermann (- m 1) 1 r))
            (exists ((v Int)) (and (ackermann m (- n 1) v) (ackermann (- m 1) v r))))))
    (=> (or (and (= m 0) (= r (+ n 1)))
        (or (and (= n 0) (ackermann (- m 1) 1 r))
            (exists ((v Int)) (and (ackermann m (- n 1) v) (ackermann (- m 1) v r)))))
        (ackermann m n r))
)))


; Goal
(assert (not 
  (forall ((m Int) (n Int) (r Int))
     (=> (and (>= m 0) (and (>= n 0) (ackermann m n r)))
         (> r n)))
))
(check-sat)