; let rec mult x y =
;   if y = 0 then 0
;   else x + mult x (y - 1)
;
; "mult_c(x, y, a, r) :- y = 0 && r = a.
;  mult_c(x, y, a, r) :- y <> 0 && mult_c(x, y - 1, a + x, r) .
;  ?- mult[0:0](x, y, r1) && mult_c(x, y, a, r2) && r1 + a <> r2.

(set-logic ALL)

(declare-fun mult   (Int Int Int)     Bool)
(declare-fun mult_c (Int Int Int Int) Bool)

; mult
(assert (forall ((x Int) (y Int) (r Int))
  (and
     (=> (mult x y r)
         (or (and (= y 0) (= r 0))
             (exists ((v Int)) (and (mult x (- y 1) v) (= r (+ x v))))))
     (=> (or (and (= y 0) (= r 0))
             (exists ((v Int)) (and (mult x (- y 1) v) (= r (+ x v)))))
         (mult x y r)))
))

; mult_c
(assert (forall ((x Int) (y Int) (a Int) (r Int))
  (and
     (=> (mult_c x y a r)
         (or (and (= y 0) (= r a))
             (and (not (= y 0)) (mult_c x (- y 1) (+ a x) r))))
     (=> (or (and (= y 0) (= r a))
             (and (not (= y 0)) (mult_c x (- y 1) (+ a x) r)))
         (mult_c x y a r))
)))

; Goal
(assert (not 
  (forall ((x Int) (y Int) (a Int) (r1 Int) (r2 Int))
    (=> (and (mult x y r1) (mult_c x y a r2))
        (= (+ r1 a) r2)))
))
(check-sat)

